using FluentValidation;
using CMSMicroservice.Protobuf.Protos.Transactions;
namespace CMSMicroservice.Protobuf.Validator.Transactions;

public class UpdateTransactionsRequestValidator : AbstractValidator<UpdateTransactionsRequest>
{
    public UpdateTransactionsRequestValidator()
    {
        RuleFor(model => model.Id)
            .NotNull();
        RuleFor(model => model.Amount)
            .NotNull();
        RuleFor(model => model.Description)
            .NotEmpty();
        RuleFor(model => model.PaymentStatus)
            .IsInEnum()
            .NotNull();
        RuleFor(model => model.Type)
            .IsInEnum()
            .NotNull();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<UpdateTransactionsRequest>.CreateWithOptions((UpdateTransactionsRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
